package fi.em.formPlugin;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.exception.KDBizException;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.botp.Draw;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.sdk.plugin.Plugin;

public class BusinessProcessingUnAuditEditPlugin  extends AbstractListPlugin implements Plugin {
    public static String deleteentryys = "deleteentryys"; //冲应收挂账

    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        if (args.getSource() instanceof Draw) {
            Draw draw = (Draw) args.getSource();
            if (draw.getOperateKey().equals("drawysgz")) {
//                int count = this.getModel().getEntryRowCount("nckd_entryentity1");
//                StringBuilder numbers = new StringBuilder();
                Object value = this.getModel().getValue("nckd_payeenamev");//获取当前单据付款人
                Object nckd_orgv = this.getModel().getValue("nckd_orgv");//获取当前单据付款人
                DynamicObject dynamicObject = (DynamicObject) value;
                DynamicObject orgv = (DynamicObject) nckd_orgv;
                if (dynamicObject == null) {
                    throw new KDBizException("收款信息付款人为空！");
                }
                if (orgv == null) {
                    throw new KDBizException("收款信息收款人为空！");
                }
                String bdsupplier = dynamicObject.getString("number");//当前单据付款供应商
                draw.getOption().setVariableValue("bdsupplier", bdsupplier);
                String orgnumber = orgv.getString("number");
                draw.getOption().setVariableValue("orgnumber", orgnumber);
                draw.getOption().setVariableValue("type", "drawysgz");
            } else if (draw.getOperateKey().equals("drawyfgz")) {
                //int count = this.getModel().getEntryRowCount("nckd_entryentity2");
                Object value = this.getModel().getValue("nckd_payeenamevs");//获取当前单据付款人
                Object nckd_orgvs = this.getModel().getValue("nckd_orgvs");//获取当前单据收款人
                DynamicObject dynamicObject = (DynamicObject) value;
                DynamicObject orgvs = (DynamicObject) nckd_orgvs;
                if (dynamicObject == null) {
                    throw new KDBizException("付款信息收款人为空！");
                }
                if (orgvs == null) {
                    throw new KDBizException("付款信息付款人为空！");
                }
                String bdsupplier = dynamicObject.getString("number");//当前单据付款供应商
                draw.getOption().setVariableValue("bdsupplier", bdsupplier);
                String orgnumber = orgvs.getString("number");
                draw.getOption().setVariableValue("orgnumber", orgnumber);
                draw.getOption().setVariableValue("type", "drawyfgz");
            }else if (draw.getOperateKey().equals("drawzlht")) {
                Object value = this.getModel().getValue("nckd_orgv");//获取当前单据核算组织
                Object nckd_payeenamevs = this.getModel().getValue("nckd_payeenamev");//获取当前单据付款人
                DynamicObject dynamicObject = (DynamicObject) value;
                DynamicObject payeenamevs = (DynamicObject) nckd_payeenamevs;
                if (dynamicObject == null) {
                    throw new KDBizException("收款信息收款人为空！");
                }
                if (payeenamevs == null) {
                    throw new KDBizException("收款信息付款人为空！");
                }
                String bdsupplier = payeenamevs.getString("number");//当前单据付款供应商
                draw.getOption().setVariableValue("bdsupplier", bdsupplier);
                String orgnumber = dynamicObject.getString("number");
                draw.getOption().setVariableValue("orgnumber", orgnumber);
                draw.getOption().setVariableValue("type", "drawzlht");
            }
        }
        super.beforeDoOperation(args);
    }
}
